## kf6-syntax-highlighting 6.18.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(KF_VERSION "6.18.0")
project(KSyntaxHighlighting VERSION ${KF_VERSION})

find_package(ECM 6.18.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDEGitCommitHooks)

include(FeatureSummary)
include(GenerateExportHeader)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(CMakePackageConfigHelpers)
include(ECMPoQmTools)
include(ECMQtDeclareLoggingCategory)
include(ECMMarkNonGuiExecutable)
include(ECMOptionalAddSubdirectory)
include(ECMGenerateExportHeader)
include(ECMDeprecationSettings)
include(ECMQmlModule)
include(ECMGenerateQDoc)

set(ksyntaxhighlighting_version_header "${CMAKE_CURRENT_BINARY_DIR}/src/lib/ksyntaxhighlighting_version.h")
ecm_setup_version(PROJECT
    VARIABLE_PREFIX KSYNTAXHIGHLIGHTING
    VERSION_HEADER "${ksyntaxhighlighting_version_header}"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF6SyntaxHighlightingConfigVersion.cmake"
    SOVERSION 6
)

set(EXCLUDE_DEPRECATED_BEFORE_AND_AT 0 CACHE STRING "Control the range of deprecated API excluded from the build [default=0].")

#
# Dependencies
#
set(REQUIRED_QT_VERSION 6.7.0)
find_package(Qt6 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED COMPONENTS Core Network Test)
option(KSYNTAXHIGHLIGHTING_USE_GUI "Build components depending on QtGui" ON)
if(KSYNTAXHIGHLIGHTING_USE_GUI)
    find_package(Qt6 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED COMPONENTS Gui)
endif()
find_package(Qt6 ${REQUIRED_QT_VERSION} NO_MODULE QUIET OPTIONAL_COMPONENTS PrintSupport Widgets Quick)
set_package_properties(Qt6 PROPERTIES URL "http://qt-project.org/")
set_package_properties(Qt6Widgets PROPERTIES PURPOSE "Example application.")
set_package_properties(Qt6PrintSupport PROPERTIES PURPOSE "Example application.")
set_package_properties(Qt6Quick PROPERTIES PURPOSE "QtQuick bindings.")

# https://xerces.apache.org/index.html for validation
find_package (XercesC)
set_package_properties(XercesC PROPERTIES PURPOSE "Compile-time validation of syntax definition files.")

find_package(Perl REQUIRED)
set_package_properties(Perl PROPERTIES PURPOSE "Auto-generate PHP syntax definition files.")

#
# allow to install the "differently" licensed syntax xml files instead of putting them in a QRC and link them in
#
option(QRC_SYNTAX "Bundle the syntax definition files inside the library as resources" ON)
add_feature_info(SYNTAX_RESOURCE ${QRC_SYNTAX} "Bundle the syntax definition files inside the library as resources")

#
# allow to turn of lookup for syntax files and themes via QStandardPaths
#
option(NO_STANDARD_PATHS "Skip lookup of syntax and theme definitions in QStandardPaths locations" OFF)
add_feature_info(FEATURE_NO_STANDARD_PATHS ${NO_STANDARD_PATHS} "Skip lookup of syntax and theme definitions in QStandardPaths locations")

#
# Translations
#
ecm_install_po_files_as_qm(poqm)

# tell the framework if it shall use the syntax files from the resource
if (QRC_SYNTAX)
    add_definitions(-DHAS_SYNTAX_RESOURCE)
endif()

# skip standard paths?
if (NO_STANDARD_PATHS)
    add_definitions(-DNO_STANDARD_PATHS)
endif()

ecm_set_disabled_deprecation_versions(
    QT 6.10.0
)

#
# Actually build the stuff
#
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_subdirectory(data)
add_subdirectory(src)
if(TARGET Qt6::Gui)
    add_subdirectory(examples)
    if (BUILD_TESTING)
        add_subdirectory(autotests)
    endif()
endif()

#
# CMake package config file generation
#
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF6SyntaxHighlighting")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KF6SyntaxHighlightingConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KF6SyntaxHighlightingConfig.cmake"
    INSTALL_DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
)

install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KF6SyntaxHighlightingConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KF6SyntaxHighlightingConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel)

if(TARGET KF6SyntaxHighlighting)
    install(EXPORT KF6SyntaxHighlightingTargets
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        FILE KF6SyntaxHighlightingTargets.cmake
        NAMESPACE KF6::)
endif()

install(FILES "${ksyntaxhighlighting_version_header}"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR_KF}/KSyntaxHighlighting"
        COMPONENT Devel)

include(ECMFeatureSummary)
ecm_feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

# add target to update kate-editor.org syntax page + update site
add_custom_target(update_kate_editor_org
    COMMAND "${PERL_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/utils/update-kate-editor-org.pl" "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}")

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== src/lib/CMakeLists.txt ===
add_library(KF6SyntaxHighlighting)

set_target_properties(KF6SyntaxHighlighting PROPERTIES
    VERSION     ${KSYNTAXHIGHLIGHTING_VERSION}
    SOVERSION   ${KSYNTAXHIGHLIGHTING_SOVERSION}
    EXPORT_NAME SyntaxHighlighting
)

ecm_create_qm_loader(syntax_highlighting_QM_LOADER syntaxhighlighting6_qt)

target_sources(KF6SyntaxHighlighting PRIVATE
    abstracthighlighter.cpp
    context.cpp
    contextswitch.cpp
    definitiondownloader.cpp
    highlightingdata.cpp
    foldingregion.cpp
    format.cpp
    htmlhighlighter.cpp
    ansihighlighter.cpp
    keywordlist.cpp
    rule.cpp
    definition.cpp
    repository.cpp
    state.cpp
    syntaxhighlighter.cpp
    theme.cpp
    wildcardmatcher.cpp
    themedata.cpp
    worddelimiters.cpp
    ${syntax_highlighting_QM_LOADER}
    $<TARGET_OBJECTS:SyntaxHighlightingData>
)
ecm_qt_declare_logging_category(KF6SyntaxHighlighting
    HEADER ksyntaxhighlighting_logging.h
    IDENTIFIER KSyntaxHighlighting::Log
    CATEGORY_NAME kf.syntaxhighlighting
    OLD_CATEGORY_NAMES org.kde.ksyntaxhighlighting
    DESCRIPTION "Syntax Highlighting"
    EXPORT KSYNTAXHIGHLIGHTING
)

ecm_generate_export_header(KF6SyntaxHighlighting
    BASE_NAME KSyntaxHighlighting
    GROUP_BASE_NAME KF
    VERSION ${KF_VERSION}
    USE_VERSION_HEADER
    DEPRECATED_BASE_VERSION 0
    DEPRECATION_VERSIONS
    EXCLUDE_DEPRECATED_BEFORE_AND_AT ${EXCLUDE_DEPRECATED_BEFORE_AND_AT}
)

target_link_libraries(KF6SyntaxHighlighting
    PUBLIC
        Qt6::Gui
    PRIVATE
        Qt6::Network
)

set(Forwarding_Header_Names
    AbstractHighlighter
    Definition
    DefinitionDownloader
    FoldingRegion
    Format
    Repository
    State
    SyntaxHighlighter
    Theme
    WildcardMatcher
)

ecm_generate_headers(CamelCase_HEADERS
    HEADER_NAMES ${Forwarding_Header_Names}
    REQUIRED_HEADERS SyntaxHighlighting_HEADERS
    OUTPUT_DIR ${CMAKE_BINARY_DIR}/KSyntaxHighlighting/KSyntaxHighlighting
)

target_include_directories(KF6SyntaxHighlighting
    INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/KSyntaxHighlighting>"
    PUBLIC "$<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/KSyntaxHighlighting;>"
)

install(TARGETS KF6SyntaxHighlighting EXPORT KF6SyntaxHighlightingTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES
    ${CamelCase_HEADERS}
    ${SyntaxHighlighting_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/ksyntaxhighlighting_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KSyntaxHighlighting/KSyntaxHighlighting
)


ecm_generate_qdoc(KF6SyntaxHighlighting ksyntaxhighlighting.qdocconf)

=== src/quick/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2018 Eike Hein <hein@kde.org>
# SPDX-FileCopyrightText: 2021 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-3-Clause

ecm_add_qml_module(kquicksyntaxhighlightingplugin URI "org.kde.syntaxhighlighting")

target_sources(kquicksyntaxhighlightingplugin PRIVATE
    kquicksyntaxhighlightingplugin.cpp
    kquicksyntaxhighlighter.cpp
)
target_link_libraries(kquicksyntaxhighlightingplugin PRIVATE
    KF6SyntaxHighlighting
    Qt6::Quick
)

ecm_finalize_qml_module(kquicksyntaxhighlightingplugin DESTINATION ${KDE_INSTALL_QMLDIR})

ecm_generate_qdoc(kquicksyntaxhighlightingplugin ksyntaxhighlightingqml.qdocconf)

=== debian/changelog ===
kf6-syntax-highlighting (6.18.0-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (6.18.0).
  * Update build-deps and deps with the info from cmake.
  * Update list of installed files.

 -- Patrick Franz <deltaone@debian.org>  Tue, 30 Sep 2025 19:15:54 +0200

=== debian/control ===
Source: kf6-syntax-highlighting
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-qmldeps,
               cmake (>= 3.16~),
               doxygen,
               extra-cmake-modules (>= 6.18.0~),
               libxerces-c-dev,
               libxkbcommon-dev,
               perl:any,
               pkgconf,
               qt6-base-dev (>= 6.7.0~),
               qt6-base-dev:native (>= 6.7.0~),
               qt6-declarative-dev (>= 6.7.0~),
               qt6-tools-dev (>= 6.5.0~),
               qt6-tools-dev:native,
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/frameworks/syntax-highlighting
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting.git
Rules-Requires-Root: no

Package: libkf6syntaxhighlighting-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Syntax highlighting Engine - translations
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 This package provides the translations.

Package: libkf6syntaxhighlighting-dev
Section: libdevel
Architecture: any
Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
         qml6-module-org-kde-syntaxhighlighting (= ${binary:Version}),
         qt6-base-dev (>= 6.7.0~),
         qt6-declarative-dev (>= 6.7.0~),
         ${misc:Depends},
Recommends: libkf6syntaxhighlighting-doc (= ${source:Version}),
Multi-Arch: same
Description: Syntax highlighting Engine
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 Contains development files for libkf6syntaxhighlighting6.

Package: libkf6syntaxhighlighting-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Section: doc
Description: Syntax highlighting Engine (documentation)
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.

Package: libkf6syntaxhighlighting-tools
Architecture: any
Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Syntax highlighting Engine
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 Provides additional tools for libkf6syntaxhighlighting6

Package: libkf6syntaxhighlighting6
Architecture: any
Multi-Arch: same
Depends: libkf6syntaxhighlighting-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Syntax highlighting Engine
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.

Package: qml6-module-org-kde-syntaxhighlighting
Architecture: any
Multi-Arch: same
Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: Syntax highlighting Engine (QML module)
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 This package contains the QtQuick QML module.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

archs_that_need_atomic = armel m68k powerpc sh4
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
	export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON

## kf6-syntax-highlighting 6.18.0+p24.04+vstable+git20250928.0546

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-set(KF_VERSION "6.18.0")
+set(KF_VERSION "6.19.0")
 project(KSyntaxHighlighting VERSION ${KF_VERSION})
 
 find_package(ECM 6.18.0 REQUIRED NO_MODULE)

=== debian/changelog ===
kf6-syntax-highlighting (6.18.0+p24.04+vstable+git20250928.0546-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 28 Sep 2025 05:46:47 +0000

kf6-syntax-highlighting (6.18.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 08 Sep 2025 23:14:39 +0000

kf6-syntax-highlighting (6.17.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 09 Aug 2025 00:37:35 +0000

kf6-syntax-highlighting (6.16.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 11 Jul 2025 06:53:58 +0000

kf6-syntax-highlighting (6.15.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 16 Jun 2025 06:11:19 +0000

kf6-syntax-highlighting (6.14.0-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Wed, 07 May 2025 23:50:04 +1000

kf6-syntax-highlighting (6.13.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 13 Apr 2025 02:19:32 +0000

kf6-syntax-highlighting (6.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 17 Mar 2025 22:23:28 +0000

kf6-syntax-highlighting (6.11.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 20 Feb 2025 03:46:16 +0000

kf6-syntax-highlighting (6.10.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 09 Jan 2025 12:31:31 +0000

kf6-syntax-highlighting (6.9.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 13 Dec 2024 10:46:49 +0000

kf6-syntax-highlighting (6.8.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 09 Nov 2024 01:19:00 +0000

kf6-syntax-highlighting (6.7.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 15 Oct 2024 15:43:45 +0000

kf6-syntax-highlighting (6.6.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 21 Sep 2024 03:51:48 +0000

kf6-syntax-highlighting (6.5.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 14 Aug 2024 13:00:41 +0000

kf6-syntax-highlighting (6.4.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 15 Jul 2024 06:51:34 +0000

kf6-syntax-highlighting (6.3.0-1neon) noble; urgency=medium

  * new release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Thu, 13 Jun 2024 14:35:56 +1000

kf6-syntax-highlighting (6.3.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 11 Jun 2024 04:07:44 +0000

kf6-syntax-highlighting (6.2.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 21 Feb 2024 16:31:52 +0000

kf6-syntax-highlighting (5.245.0-0neon) jammy; urgency=medium

  * New alpha release

 -- Neon CI <neon@kde.org>  Fri, 17 Nov 2023 01:18:08 +0000

kf6-syntax-highlighting (0.0-0neon) UNRELEASED; urgency=medium

  * New release

 -- Jonathan Esk-Riddell <jr@jriddell.org>  Mon, 12 Dec 2022 13:04:30 +0000

## kf6-syntax-highlighting 6.18.0+p24.04+vstable+git20250930.0303

=== debian/changelog ===
kf6-syntax-highlighting (6.18.0+p24.04+vstable+git20250930.0303-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 30 Sep 2025 03:03:48 +0000

## kf6-syntax-highlighting 6.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(KF_VERSION "6.19.0")
 project(KSyntaxHighlighting VERSION ${KF_VERSION})
 
-find_package(ECM 6.18.0 REQUIRED NO_MODULE)
+find_package(ECM 6.19.0 REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
 
 include(KDEInstallDirs)

=== autotests/CMakeLists.txt ===
#
# test configuration
#
configure_file(test-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/test-config.h)

#
# helper to update the references for the unit tests
#
configure_file(update-reference-data.sh.in ${CMAKE_CURRENT_BINARY_DIR}/update-reference-data.sh)

#
# unit tests
# always executed during testing, required to pass, else stuff is in a bad shape ;=)
#
add_executable(wildcardmatcher_test wildcardmatcher_test.cpp)
ecm_mark_nongui_executable(wildcardmatcher_test)
add_test(NAME wildcardmatcher_test COMMAND wildcardmatcher_test)
target_link_libraries(wildcardmatcher_test KF6SyntaxHighlighting Qt6::Test)

add_executable(repository_test repository_test_base.cpp repository_test.cpp)
ecm_mark_nongui_executable(repository_test)
add_test(NAME repository_test COMMAND repository_test)
target_link_libraries(repository_test KF6SyntaxHighlighting Qt6::Test)

add_executable(theme_test theme_test.cpp)
ecm_mark_nongui_executable(theme_test)
add_test(NAME theme_test COMMAND theme_test)
target_link_libraries(theme_test KF6SyntaxHighlighting Qt6::Test)

add_executable(testhighlighter_test testhighlighter.cpp)
ecm_mark_nongui_executable(testhighlighter_test)
add_test(NAME testhighlighter_test COMMAND testhighlighter_test)
target_link_libraries(testhighlighter_test KF6SyntaxHighlighting Qt6::Test)

add_executable(htmlhighlighter_test htmlhighlighter_test.cpp)
ecm_mark_nongui_executable(htmlhighlighter_test)
add_test(NAME htmlhighlighter_test COMMAND htmlhighlighter_test)
target_link_libraries(htmlhighlighter_test KF6SyntaxHighlighting Qt6::Test)

add_executable(folding_test foldingtest.cpp)
ecm_mark_nongui_executable(folding_test)
add_test(NAME folding_test COMMAND folding_test)
target_link_libraries(folding_test KF6SyntaxHighlighting Qt6::Test)

#
# benchmarks, don't execute during normal testing
# they don't test additional stuff but only hang the CI
#
add_executable(highlighter_benchmark highlighter_benchmark.cpp)
ecm_mark_nongui_executable(highlighter_benchmark)
add_test(NAME highlighter_benchmark COMMAND highlighter_benchmark CONFIGURATIONS BENCHMARK)
target_link_libraries(highlighter_benchmark KF6SyntaxHighlighting Qt6::Test)

add_executable(repository_benchmark repository_test_base.cpp repository_benchmark.cpp)
ecm_mark_nongui_executable(repository_benchmark)
add_test(NAME repository_benchmark COMMAND repository_benchmark CONFIGURATIONS BENCHMARK)
target_link_libraries(repository_benchmark KF6SyntaxHighlighting Qt6::Test)

=== examples/minimal/CMakeLists.txt ===
if(TARGET Qt6::Widgets)
    add_executable(minimal main.cpp)
    target_link_libraries(minimal Qt6::Widgets KF6SyntaxHighlighting)
endif()

=== src/quick/CMakeLists.txt ===
--- 
+++ 
@@ -2,11 +2,11 @@
 # SPDX-FileCopyrightText: 2021 Volker Krause <vkrause@kde.org>
 # SPDX-License-Identifier: BSD-3-Clause
 
-ecm_add_qml_module(kquicksyntaxhighlightingplugin URI "org.kde.syntaxhighlighting")
+ecm_add_qml_module(kquicksyntaxhighlightingplugin URI "org.kde.syntaxhighlighting" GENERATE_PLUGIN_SOURCE VERSION 1.0)
 
 target_sources(kquicksyntaxhighlightingplugin PRIVATE
-    kquicksyntaxhighlightingplugin.cpp
     kquicksyntaxhighlighter.cpp
+    types.cpp
 )
 target_link_libraries(kquicksyntaxhighlightingplugin PRIVATE
     KF6SyntaxHighlighting

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (6.18.0)
  * New upstream release (6.19.0)

 -- Rik Mills <rikmills@kde.org>  Sun, 12 Oct 2025 15:09:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,28 @@
 Source: kf6-syntax-highlighting
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Patrick Franz <deltaone@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
                dh-sequence-qmldeps,
-               cmake (>= 3.16~),
                doxygen,
-               extra-cmake-modules (>= 6.18.0~),
+               extra-cmake-modules (>= 6.19.0~),
                libxerces-c-dev,
                libxkbcommon-dev,
                perl:any,
                pkgconf,
-               qt6-base-dev (>= 6.7.0~),
-               qt6-base-dev:native (>= 6.7.0~),
-               qt6-declarative-dev (>= 6.7.0~),
+               qt6-base-dev (>= 6.5.0+dfsg~),
+               qt6-declarative-dev (>= 6.5.0+dfsg~),
                qt6-tools-dev (>= 6.5.0~),
-               qt6-tools-dev:native,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.0
 Homepage: https://invent.kde.org/frameworks/syntax-highlighting
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-syntax-highlighting
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-syntax-highlighting
 Rules-Requires-Root: no
 
 Package: libkf6syntaxhighlighting-data
@@ -45,8 +44,8 @@
 Architecture: any
 Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
          qml6-module-org-kde-syntaxhighlighting (= ${binary:Version}),
-         qt6-base-dev (>= 6.7.0~),
-         qt6-declarative-dev (>= 6.7.0~),
+         qt6-base-dev (>= 6.5.0+dfsg~),
+         qt6-declarative-dev (>= 6.5.0+dfsg~),
          ${misc:Depends},
 Recommends: libkf6syntaxhighlighting-doc (= ${source:Version}),
 Multi-Arch: same

## kf6-syntax-highlighting 6.19.0+p24.04+vstable+git20251019.0059

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vstable+git20251019.0059-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 00:59:07 +0000

kf6-syntax-highlighting (6.19.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 08 Oct 2025 07:18:13 +0000

## kf6-syntax-highlighting 6.19.0+p24.04+vstable+git20251019.0557

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vstable+git20251019.0557-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 05:57:47 +0000

## kf6-syntax-highlighting 6.19.0+p24.04+vstable+git20251024.0115

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vstable+git20251024.0115-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 24 Oct 2025 01:15:18 +0000

=== debian/control ===
Source: kf6-syntax-highlighting
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               graphviz,
               kde-qdoc-common-dev,
               kf6-extra-cmake-modules,
               libxerces-c-dev,
               perl,
               pkg-kde-tools-neon,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev
Standards-Version: 4.6.2
Homepage: https://projects.kde.org/projects/frameworks/syntax-highlighting
Vcs-Git: https://invent.kde.org/neon/kf6/kf6-syntax-highlighting.git
Vcs-Browser: https://invent.kde.org/neon/kf6/kf6-syntax-highlighting
Maintainer: Neon CI <neon@kde.org>

Package: kf6-syntax-highlighting
Architecture: any
Section: kde
X-Neon-MergedPackage: true
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libkf6syntaxhighlighting-data,
          libkf6syntaxhighlighting-tools,
          libkf6syntaxhighlighting6,
          qml6-module-org-kde-syntaxhighlighting
Description: Syntax highlighting Engine - translations
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 This package provides the translations.

Package: kf6-syntax-highlighting-dev
Architecture: any
Section: kde
X-Neon-MergedPackage: true
Depends: kf6-syntax-highlighting (= ${binary:Version}),
         qt6-base-dev,
         qt6-declarative-dev,
         ${misc:Depends}
Replaces: libkf6syntaxhighlighting-dev, libkf6syntaxhighlighting-doc
Description: Syntax highlighting Engine
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 Contains development files for libkf6syntaxhighlighting6.

Package: libkf6syntaxhighlighting6
Architecture: all
Depends: kf6-syntax-highlighting, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6syntaxhighlighting-data
Architecture: all
Depends: kf6-syntax-highlighting, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6syntaxhighlighting-dev
Architecture: all
Depends: kf6-syntax-highlighting-dev, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6syntaxhighlighting-doc
Architecture: all
Depends: kf6-syntax-highlighting-dev, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: libkf6syntaxhighlighting-tools
Architecture: all
Depends: kf6-syntax-highlighting, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

Package: qml6-module-org-kde-syntaxhighlighting
Architecture: all
Depends: kf6-syntax-highlighting, ${misc:Depends}
Description: Dummy transitional
 Transitional dummy package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export KDE_DOCS=/usr/share/qt6/doc/kde-qdoc-common-dev

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- -DFEATURE_NO_STANDARD_PATHS=OFF

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- prepare_docs
	dh_auto_build -- generate_docs
	dh_auto_build -- generate_qch

override_dh_auto_install:
	dh_auto_install
	dh_auto_install -- install_html_docs
	dh_auto_install -- install_qch_docs

## kf6-syntax-highlighting 6.19.0+p24.04+vstable+git20251028.0747

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-set(KF_VERSION "6.19.0")
+set(KF_VERSION "6.20.0")
 project(KSyntaxHighlighting VERSION ${KF_VERSION})
 
 find_package(ECM 6.19.0 REQUIRED NO_MODULE)
@@ -38,7 +38,7 @@
 #
 # Dependencies
 #
-set(REQUIRED_QT_VERSION 6.7.0)
+set(REQUIRED_QT_VERSION 6.8.0)
 find_package(Qt6 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED COMPONENTS Core Network Test)
 option(KSYNTAXHIGHLIGHTING_USE_GUI "Build components depending on QtGui" ON)
 if(KSYNTAXHIGHLIGHTING_USE_GUI)

=== src/lib/CMakeLists.txt ===
--- 
+++ 
@@ -50,6 +50,7 @@
     EXCLUDE_DEPRECATED_BEFORE_AND_AT ${EXCLUDE_DEPRECATED_BEFORE_AND_AT}
 )
 
+qt_extract_metatypes(KF6SyntaxHighlighting)
 target_link_libraries(KF6SyntaxHighlighting
     PUBLIC
         Qt6::Gui
@@ -73,12 +74,11 @@
 ecm_generate_headers(CamelCase_HEADERS
     HEADER_NAMES ${Forwarding_Header_Names}
     REQUIRED_HEADERS SyntaxHighlighting_HEADERS
-    OUTPUT_DIR ${CMAKE_BINARY_DIR}/KSyntaxHighlighting/KSyntaxHighlighting
+    SHARED_PREFIX KSyntaxHighlighting
 )
 
 target_include_directories(KF6SyntaxHighlighting
     INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/KSyntaxHighlighting>"
-    PUBLIC "$<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/KSyntaxHighlighting;>"
 )
 
 install(TARGETS KF6SyntaxHighlighting EXPORT KF6SyntaxHighlightingTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vstable+git20251028.0747-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 28 Oct 2025 07:48:08 +0000

## kf6-syntax-highlighting 6.19.0+p24.04+vstable+git20251031.0310

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vstable+git20251031.0310-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 31 Oct 2025 03:10:31 +0000

## kf6-syntax-highlighting 6.19.0+p24.04+vunstable+git20251008.1153

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,7 +38,7 @@
 #
 # Dependencies
 #
-set(REQUIRED_QT_VERSION 6.8.0)
+set(REQUIRED_QT_VERSION 6.7.0)
 find_package(Qt6 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED COMPONENTS Core Network Test)
 option(KSYNTAXHIGHLIGHTING_USE_GUI "Build components depending on QtGui" ON)
 if(KSYNTAXHIGHLIGHTING_USE_GUI)

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vunstable+git20251008.1153-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 08 Oct 2025 11:53:51 +0000

## kf6-syntax-highlighting 6.19.0+p24.04+vunstable+git20251015.0928

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vunstable+git20251015.0928-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 09:28:30 +0000

## kf6-syntax-highlighting 6.19.0+p24.04+vunstable+git20251019.0558

=== debian/changelog ===
kf6-syntax-highlighting (6.19.0+p24.04+vunstable+git20251019.0558-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 05:58:34 +0000

## kf6-syntax-highlighting 6.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(KF_VERSION "6.20.0")
 project(KSyntaxHighlighting VERSION ${KF_VERSION})
 
-find_package(ECM 6.19.0 REQUIRED NO_MODULE)
+find_package(ECM 6.20.0 REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
 
 include(KDEInstallDirs)
@@ -38,7 +38,7 @@
 #
 # Dependencies
 #
-set(REQUIRED_QT_VERSION 6.7.0)
+set(REQUIRED_QT_VERSION 6.8.0)
 find_package(Qt6 ${REQUIRED_QT_VERSION} NO_MODULE REQUIRED COMPONENTS Core Network Test)
 option(KSYNTAXHIGHLIGHTING_USE_GUI "Build components depending on QtGui" ON)
 if(KSYNTAXHIGHLIGHTING_USE_GUI)

=== debian/changelog ===
kf6-syntax-highlighting (6.20.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (6.20.0).
  * Update build-deps and deps with the info from cmake.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 15 Nov 2025 19:24:09 +0100

=== debian/control ===
Source: kf6-syntax-highlighting
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-qmldeps,
               cmake (>= 3.16~),
               doxygen,
               extra-cmake-modules (>= 6.20.0~),
               libxerces-c-dev,
               libxkbcommon-dev,
               perl:any,
               pkgconf,
               qt6-base-dev (>= 6.8.0~),
               qt6-base-dev:native (>= 6.8.0~),
               qt6-declarative-dev (>= 6.8.0~),
               qt6-tools-dev (>= 6.5.0~),
               qt6-tools-dev:native,
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/frameworks/syntax-highlighting
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting.git
Rules-Requires-Root: no

Package: libkf6syntaxhighlighting-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Syntax highlighting Engine - translations
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 This package provides the translations.

Package: libkf6syntaxhighlighting-dev
Section: libdevel
Architecture: any
Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
         qml6-module-org-kde-syntaxhighlighting (= ${binary:Version}),
         qt6-base-dev (>= 6.8.0~),
         qt6-declarative-dev (>= 6.8.0~),
         ${misc:Depends},
Recommends: libkf6syntaxhighlighting-doc (= ${source:Version}),
Multi-Arch: same
Description: Syntax highlighting Engine
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 Contains development files for libkf6syntaxhighlighting6.

Package: libkf6syntaxhighlighting-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Section: doc
Description: Syntax highlighting Engine (documentation)
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.

Package: libkf6syntaxhighlighting-tools
Architecture: any
Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Syntax highlighting Engine
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 Provides additional tools for libkf6syntaxhighlighting6

Package: libkf6syntaxhighlighting6
Architecture: any
Multi-Arch: same
Depends: libkf6syntaxhighlighting-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Syntax highlighting Engine
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.

Package: qml6-module-org-kde-syntaxhighlighting
Architecture: any
Multi-Arch: same
Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: Syntax highlighting Engine (QML module)
 This is a stand-alone implementation of the Kate syntax
 highlighting engine. It's meant as a building block for
 text editors as well as for simple highlighted text
 rendering (e.g. as HTML), supporting both integration
 with a custom editor as well as a ready-to-use
 QSyntaxHighlighter sub-class.
 .
 This package contains the QtQuick QML module.

## kf6-syntax-highlighting 6.20.0+p24.04+vunstable+git20251203.0048

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-set(KF_VERSION "6.20.0")
+set(KF_VERSION "6.21.0")
 project(KSyntaxHighlighting VERSION ${KF_VERSION})
 
 find_package(ECM 6.20.0 REQUIRED NO_MODULE)
@@ -56,6 +56,9 @@
 
 find_package(Perl REQUIRED)
 set_package_properties(Perl PROPERTIES PURPOSE "Auto-generate PHP syntax definition files.")
+
+find_package(Python)
+set_package_properties(Python PROPERTIES PURPOSE "Auto-generate Jinja syntax definition files.")
 
 #
 # allow to install the "differently" licensed syntax xml files instead of putting them in a QRC and link them in

=== debian/changelog ===
kf6-syntax-highlighting (6.20.0+p24.04+vunstable+git20251203.0048-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 03 Dec 2025 00:48:09 +0000

kf6-syntax-highlighting (6.20.0-0neon) Noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 22 Nov 2025 15:33:46 +1000

## kf6-syntax-highlighting 6.20.0+p24.04+vunstable+git20251204.0127

=== debian/changelog ===
kf6-syntax-highlighting (6.20.0+p24.04+vunstable+git20251204.0127-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 04 Dec 2025 01:27:25 +0000

## kf6-syntax-highlighting 6.21.0

=== data/CMakeLists.txt ===
# create a directory for generated definitions
execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/generated/syntax)

macro(generate_syntax_definition generator targetFile srcFile)
    add_custom_target(
        ${targetFile} ALL
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/generated/syntax/${targetFile}
    )
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/generated/syntax/${targetFile}
        COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/generators/${generator}
                ${CMAKE_CURRENT_SOURCE_DIR}/syntax/${srcFile}
                ${CMAKE_CURRENT_BINARY_DIR}/generated/syntax/${targetFile}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/generators/${generator}
                ${CMAKE_CURRENT_SOURCE_DIR}/syntax/${srcFile}
                ${ARGN}
        VERBATIM
    )
    set(gen_defs ${gen_defs} ${CMAKE_CURRENT_BINARY_DIR}/generated/syntax/${targetFile})
endmacro()

macro(generate_syntax_definition_with_html syntax mergedSyntax)
    generate_syntax_definition(generate-html.pl ${mergedSyntax}-${syntax}.xml ${mergedSyntax}.xml ${CMAKE_CURRENT_SOURCE_DIR}/syntax/${syntax}.xml)
endmacro()

# generate PHP definitions
generate_syntax_definition_with_html(php html)
generate_syntax_definition_with_html(php css)
generate_syntax_definition_with_html(php javascript)
generate_syntax_definition_with_html(php javascript-react)
generate_syntax_definition_with_html(php typescript)
generate_syntax_definition_with_html(php mustache)

# generate Twig definitions
generate_syntax_definition_with_html(twig html)
generate_syntax_definition_with_html(twig css)
generate_syntax_definition_with_html(twig javascript)
generate_syntax_definition_with_html(twig javascript-react)
generate_syntax_definition_with_html(twig typescript)

# generate DoxygenLua definition
generate_syntax_definition(generate-doxygenlua.pl doxygenlua.xml doxygen.xml)

# generate XSLT definition
generate_syntax_definition(generate-xslt.pl xslt.xml xml.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/generators/xslt.base.xml
)

# generate JSONC definition
generate_syntax_definition(generate-jsonc.pl jsonc.xml json.xml)

# generate Jinja definitions
if(Python_FOUND)
    set(jinja_langs html css xml json yaml toml sql python cpp qml java groovy rust javascript typescript ruby cmake qmake ini bash zsh dockerfile terraform systemd-unit)
    set(jinja_indir ${CMAKE_CURRENT_SOURCE_DIR}/syntax)
    set(jinja_outdir ${CMAKE_CURRENT_BINARY_DIR}/generated/syntax)
    set(jinja_prefix jinja-)
    list(TRANSFORM jinja_langs REPLACE "(.+)" "${jinja_indir}/\\1.xml" OUTPUT_VARIABLE in_xmls)

    execute_process(
        COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/generators/generate_jinja.py --dry-run
                --jinja-xml ${CMAKE_CURRENT_SOURCE_DIR}/syntax/jinja.xml
                --prefix ${jinja_prefix}
                --output-dir ${jinja_outdir}
                ${in_xmls}
        OUTPUT_VARIABLE out_xmls
        RESULT_VARIABLE dry_run
    )

    if(${dry_run} EQUAL 0)
        string(REPLACE "\r" "" out_xmls ${out_xmls})
        string(REPLACE "\n" ";" out_xmls ${out_xmls})
        file(TO_CMAKE_PATH "${out_xmls}" out_xmls)
        list(TRANSFORM out_xmls REPLACE ${jinja_outdir} ${jinja_indir} OUTPUT_VARIABLE in_xmls)
        list(TRANSFORM in_xmls REPLACE ${jinja_prefix} "")

        add_custom_target(
            generate-jinja ALL
            DEPENDS ${out_xmls}
        )
        add_custom_command(
            OUTPUT ${out_xmls}
            COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/generators/generate_jinja.py
                    --jinja-xml ${CMAKE_CURRENT_SOURCE_DIR}/syntax/jinja.xml
                    --prefix ${jinja_prefix}
                    --output-dir ${jinja_outdir}
                    ${in_xmls}
            DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/generators/generate_jinja.py
                    ${CMAKE_CURRENT_SOURCE_DIR}/syntax/jinja.xml
                    ${in_xmls}
            VERBATIM
        )
        set(gen_defs ${gen_defs} ${out_xmls})
    else()
        message(NOTICE "There was an error with the Jinja generator tool, left out of build.")
    endif()
endif()

# find all definitions
file(GLOB src_defs "${CMAKE_CURRENT_SOURCE_DIR}/syntax/*.xml")
set(defs ${src_defs} ${gen_defs})

# object library to make cross-folder dependencies work
add_library(SyntaxHighlightingData OBJECT)

# theme data resource
target_sources(SyntaxHighlightingData PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/themes/theme-data.qrc)

# generate the resource file
set(compressed_xml_dir ${CMAKE_CURRENT_BINARY_DIR}/generated/compressed-syntax)
set(qrc_xml_file ${CMAKE_CURRENT_BINARY_DIR}/syntax-data-xml.qrc)
set(qrc_file ${CMAKE_CURRENT_BINARY_DIR}/syntax-data.qrc)
set(qrc_xml_body "")
set(qrc_body "")
foreach(def ${defs})
    get_filename_component(def_name ${def} NAME)
    string(APPEND qrc_body "<file alias=\"${def_name}\">${compressed_xml_dir}/${def_name}</file>\n")
    string(APPEND qrc_xml_body "<file>${def}</file>\n")
    set(compressedDefs ${compressedDefs} ${compressed_xml_dir}/${def_name})
endforeach()
write_file(${qrc_xml_file} "<!DOCTYPE RCC>\n<RCC>${qrc_xml_body}</RCC>")
set(SYNTAX_DATA_QRC_FILES_STRING ${qrc_body})
configure_file(syntax-data.qrc.in ${qrc_file} @ONLY)

# compress xml files
execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${compressed_xml_dir})

# generate the index file
add_custom_target(katesyntax DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/index.katesyntax")
add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/index.katesyntax"
    COMMAND katehighlightingindexer
        "${CMAKE_CURRENT_BINARY_DIR}/index.katesyntax"
        "${CMAKE_CURRENT_SOURCE_DIR}/schema/language.xsd"
        "${qrc_xml_file}"
        "${compressed_xml_dir}"
    DEPENDS katehighlightingindexer
        ${defs}
        ${qrc_file}
        ${CMAKE_CURRENT_SOURCE_DIR}/schema/language.xsd
)

# do we want syntax files bundled in the library?
if (QRC_SYNTAX)
    # generate the qrc file manually, to make dependencies on generated files work...
    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/qrc_syntax-data.cpp"
        COMMAND Qt6::rcc --name syntax_data -o "${CMAKE_CURRENT_BINARY_DIR}/qrc_syntax-data.cpp" "${qrc_file}"
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/index.katesyntax
    )
    set_source_files_properties("${CMAKE_CURRENT_BINARY_DIR}/qrc_syntax-data.cpp" PROPERTIES SKIP_AUTOMOC ON)

    target_sources(SyntaxHighlightingData PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/qrc_syntax-data.cpp)
else()
    add_dependencies(SyntaxHighlightingData katesyntax)
    # install the syntax files as normal files into the prefix
    install (FILES "${CMAKE_CURRENT_BINARY_DIR}/index.katesyntax" ${compressedDefs} DESTINATION ${KDE_INSTALL_DATADIR}/org.kde.syntax-highlighting/syntax-bundled)
endif()

# set PIC to allow use in static and shared libs
# this needs some more recent CMake than generally required
set_property(TARGET SyntaxHighlightingData PROPERTY POSITION_INDEPENDENT_CODE 1)
if(NOT ${CMAKE_VERSION} VERSION_LESS "3.13.0")
    target_link_libraries(SyntaxHighlightingData PRIVATE Qt6::Core)
endif()

=== debian/changelog ===
kf6-syntax-highlighting (6.21.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (6.21.0)

 -- Rik Mills <rikmills@kde.org>  Fri, 12 Dec 2025 11:54:43 +0000

kf6-syntax-highlighting (6.20.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (6.20.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 13 Nov 2025 16:17:23 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: kf6-syntax-highlighting
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Patrick Franz <deltaone@debian.org>,
 Build-Depends: debhelper-compat (= 13),
@@ -10,20 +11,18 @@
                dh-sequence-qmldeps,
                cmake (>= 3.16~),
                doxygen,
-               extra-cmake-modules (>= 6.20.0~),
+               extra-cmake-modules (>= 6.21.0~),
                libxerces-c-dev,
                libxkbcommon-dev,
                perl:any,
                pkgconf,
-               qt6-base-dev (>= 6.8.0~),
-               qt6-base-dev:native (>= 6.8.0~),
-               qt6-declarative-dev (>= 6.8.0~),
-               qt6-tools-dev (>= 6.5.0~),
-               qt6-tools-dev:native,
-Standards-Version: 4.7.2
+               qt6-base-dev (>= 6.8.0+dfsg~),
+               qt6-declarative-dev (>= 6.8.0+dfsg~),
+               qt6-tools-dev (>= 6.8.0~),
+Standards-Version: 4.7.0
 Homepage: https://invent.kde.org/frameworks/syntax-highlighting
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kf6-syntax-highlighting.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-syntax-highlighting
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-syntax-highlighting
 Rules-Requires-Root: no
 
 Package: libkf6syntaxhighlighting-data
@@ -45,8 +44,8 @@
 Architecture: any
 Depends: libkf6syntaxhighlighting6 (= ${binary:Version}),
          qml6-module-org-kde-syntaxhighlighting (= ${binary:Version}),
-         qt6-base-dev (>= 6.8.0~),
-         qt6-declarative-dev (>= 6.8.0~),
+         qt6-base-dev (>= 6.8.0+dfsg~),
+         qt6-declarative-dev (>= 6.8.0+dfsg~),
          ${misc:Depends},
 Recommends: libkf6syntaxhighlighting-doc (= ${source:Version}),
 Multi-Arch: same

## kf6-syntax-highlighting 6.21.0+p24.04+vstable+git20251226.0147

=== debian/changelog ===
kf6-syntax-highlighting (6.21.0+p24.04+vstable+git20251226.0147-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 26 Dec 2025 01:47:41 +0000

kf6-syntax-highlighting (6.21.0-0neon) Noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 07 Dec 2025 15:10:00 +1000
